/*! phoscon-app 2025-03-07 */

export const getFunctionPageView=c=>Backbone.View.extend({el:"#pageFunctions",template:_.template(document.getElementById("pageFunction-template").innerHTML),initialize:function(c){this.c=c,this.hf=this.c.helperFuncs,this.el.innerHTML=this.template(),this.service=null,this.funcListView=new FuncListModalView(this.c),this.subfuncListView=new SubfuncListModalView(this.c),this.sceneListView=new SceneListModalView(this.c),this.headLine=this.el.querySelector("#bodyRightHead span"),this.nextBtn=this.el.querySelector(".subfunc-container > button.mq-phone")},show:function(){this.el.classList.add("active-view")},hide:function(){this.el.classList.remove("active-view")},isContainerRightSet(cl){return this.el.classList.contains(cl)},setClass(cl){this.el.classList.add(cl)},removeClass(cl){this.el.classList.remove(cl)},setRightHead:function(fid){let func=this.c.rlFunctionMap.find(f=>f.class==fid);func&&(this.headLine.innerText=translate(func.translateId))},setInteractiveSvg:function(swid,dataBtn){this.swSvg=this.el.querySelector(".svg-container .interactive"),this.hf.setImage(this.swSvg,swid,this.c),setTimeout(()=>{let svg=this.el.querySelector("svg.interactive");this.hf.setActiveTarget(svg,dataBtn)},200)},enableNextBtn:function(){this.nextBtn.classList.remove("disabled")},disableNextBtn:function(page,sw){this.nextBtn.classList.add("disabled")}});const FuncWizardItemView=Backbone.View.extend({tagName:"a",className:"func list-group-item",template:_.template(document.getElementById("func-modal-list-item").innerHTML),initialize:function(){this.el.innerHTML=this.template(),this.el.setAttribute("data-btn-ev","FUNC_MODAL_PRESSED"),this.icon=this.el.querySelector(".item-icon use"),this.name=this.el.querySelector(".item-name")},render:function(func){return this.name.innerText=translate(func.translateId),this.name.setAttribute("data-translateid",func.translateId),this.icon.setAttribute("xlink:href",func.iconId),this.el.setAttribute("data-fid",func.class),this}}),FuncListModalView=Backbone.View.extend({el:"#modalFuncList",initialize:async function(c){this.c=c,this.hf=this.c.helperFuncs,this.views=[];let map=this.c.rlFunctionMap,functionsActions=[];try{switch(app.session.groupType){case"blinds":console.log("Processing BlindGroup functions..."),map.forEach(func=>{(func.class.includes("blindDown-options")||func.class.includes("blindUp-options")||func.class.includes("blindSelect-options"))&&functionsActions.push(func)});break;case"lights":console.log("Processing Light functions..."),map.forEach(func=>{(func.class.includes("dimm-options")||func.class.includes("pushdimm-options")||func.class.includes("effect-options")||func.class.includes("callscene-options")||func.class.includes("ct-options")||func.class.includes("onoff-options"))&&"blindSelect-options"!==func.class&&"thermoSelect-options"!==func.class&&functionsActions.push(func)});break;case"thermostats":console.log("Processing Thermostat functions..."),map.forEach(func=>{(func.class.includes("thermoSelect-options")||func.class.includes("thermoDown-options")||func.class.includes("thermoUp-options"))&&functionsActions.push(func)});break;default:console.log("Invalid class ID")}functionsActions.forEach(func=>{"group-mode"!==func.class&&this.addFunc(func)})}catch(error){console.error("Error:",error)}},addFunc:function(func){let view=this.views.find(v=>v.func===func);view||((view=new FuncWizardItemView).c=this.c,this.el.appendChild(view.render(func).el),this.views.push(view))},setFuncActive:function(fid){this.views.forEach(v=>{v.el.getAttribute("data-fid")==fid?v.el.classList.add("active-func"):v.el.classList.remove("active-func")})},setFunctions:function(dataBtn,sw){let longPressBtn=!1;if(!sw||!dataBtn||"undefined"===dataBtn)return;let device=app.devices.find(d=>d.get("id")==sw.get("uniqueid"));device?longPressBtn=this.c.helperFuncs.checkDeviceForLongBtn(dataBtn,device):-1!==dataBtn.indexOf("003")&&(longPressBtn=!0),1==longPressBtn?this.el.classList.add("push-dimm"):this.el.classList.remove("push-dimm"),(app.groups.get(app.session.gid).get("lights").map(l=>app.lights.get(l))||[]).find(light=>"HG06467"===light.get("modelid"))?this.el.classList.add("light-chain"):this.el.classList.remove("light-chain")}}),SubFuncItemView=Backbone.View.extend({tagName:"div",className:"func",initialize:function({c:c,func:func}){this.c=c,this.func=func;let tmpl=_.template(document.getElementById(func.templ).innerHTML);this.$el.html(tmpl()),this.$el.addClass(func.class),this.$el.addClass("model-func"),this.$temperatureDisplay=this.$("#temperature"),this.$minusBtn=this.$("#minusBtn"),this.$plusBtn=this.$("#plusBtn"),this.$degree=this.$("#degree")},events:{"click #minusBtn":"decrementTemperature","click #plusBtn":"incrementTemperature"},decrementTemperature:function(){let temp=parseInt(this.$temperatureDisplay.html());isNaN(temp)?console.error("Temperature value is not a number."):(temp--,this.$temperatureDisplay.html(temp))},incrementTemperature:function(ev){let temp=parseInt(this.$temperatureDisplay.html());isNaN(temp)?console.error("Temperature value is not a number."):(temp++,this.$temperatureDisplay.html(temp))},render:function(){return this}}),SubfuncListModalView=Backbone.View.extend({el:"#modalSubFuncList",initialize:function(c){this.c=c,this.hf=this.c.helperFuncs,this.service=null,this.views=[],this.c.rlFunctionMap.forEach(func=>{this.addFunc(func)})},addFunc:function(func){let view=new SubFuncItemView({c:this.c,func:func});this.el.appendChild(view.render().el),this.views.push(view)},setFid:function(fid){this.el.setAttribute("data-fid",fid)},getSelectValue:function(selector){let el=this.el.querySelector(selector);return"#selColor"==selector?el.value||"steady":el.value||"5"},getSelectBlindValue:function(selector){let el=this.el.querySelector(selector);return"#blindSelect"==selector?el.value||"0":el.value||"100"},getSelectThermoValue:function(selector){let el=this.el.querySelector(selector);return"#temperature"==selector?el.textContent||"0":el.textContent||"1000"}}),SceneWizardItemView=Backbone.View.extend({tagName:"option",className:"scene subfunc list-group-item",template:_.template(document.getElementById("scene-item-template").innerHTML),initialize:function({c:c,scene:scene}){this.c=c,this.model=scene,this.el.innerHTML=this.template(this.model),this.el.setAttribute("data-sid",this.model.get("id")),this.el.setAttribute("value",this.model.get("id")),this.el.setAttribute("data-btn-ev","SCENE_PRESSED")},events:{},render:function(){return this}}),SceneListModalView=Backbone.View.extend({el:".modal-body #sceneList",initialize:function(c){this.c=c,this.service=null,this.views=[],this.optionEl=document.querySelector("#modalSubFuncList .callscene-options"),this.listenTo(app.scenes,"remove",this.remove),this.listenTo(app.scenes,"add",this.addScene),this.optionEl.classList.add("empty"),app.scenes.forEach(scene=>{this.addScene(scene)})},addScene:function(scene){let view=new SceneWizardItemView({c:this.c,scene:scene});this.el.appendChild(view.render().el),this.views.push(view),this.optionEl.classList.remove("empty")},remove:function(scene){let v=this.views.find(v=>v.model==scene);v&&v.remove(),0==app.scenes.length&&this.optionEl.classList.add("empty")}});